<template>
  <v-row justify="center">
    <v-col cols="12" md="9" lg="8" xl="7">
      <h1 class="text-h1">Hello,</h1>
      <h2>Start by searching the name of the movie you want to buy or rent</h2>
      
      <v-row>
        <v-col cols="12" md="8">
          <v-form ref="form" inline>
            <v-text-field
              v-model="search"
              label="Name of the movie"
              :rules="searchRules"
            ></v-text-field>
          </v-form>
        </v-col>
        <v-col cols="12" md="4"
          ><v-btn block size="x-large" color="success" @click="searchMovies"
            >Click to Search
          </v-btn></v-col
        >
      </v-row>
    </v-col>

    <v-col cols="12" class="mt-5">
      <v-progress-linear v-if="loading" indeterminate></v-progress-linear>

      <h4 v-if="userInteracted && !loading">Results:</h4>

      <MovieList :movies="movies" v-if="movies.length"></MovieList>

      <v-alert color="warning" v-if="userInteracted && !loading && !movies.length">
        No results found. Try adding more characters to your search
        <v-btn @click="userInteracted = false">Ok</v-btn>
      </v-alert>
    </v-col>
  </v-row>

  <v-snackbar v-model="snackbar" :timeout="2000">
    {{ snackbarText }}

    <template v-slot:actions>
      <v-btn color="blue" variant="text" @click="snackbar = false"> Close </v-btn>
    </template>
  </v-snackbar>
</template>

<script>
import MovieList from './MovieList.vue'

export default {
  data() {
    return {
      loading: false,
      userInteracted: false,
      search: '',
      searchRules: [(v) => v.length >= 3 || 'Please write at least 3 characters for your search'],
      movies: [],
      snackbar: false,
      snackbarText: 'Error: Check the form'
    }
  },
  methods: {
    async searchMovies() {
      const { valid } = await this.$refs.form.validate()
      if (!valid) return
      if (this.search.length < 3) {
        this.snackbarText = 'Error: Check the form'
        this.snackbar = true
        return false
      }
      this.loading = true
      this.userInteracted = true
      try {
        const { data } = await this.axios.get(
          `https://www.omdbapi.com/?apikey=5eec5adc&s=${this.search}`
        )

        if (data.Response === 'False') {
          this.movies = []
          this.snackbarText = 'No results found'
          this.snackbar = true
          this.loading = false
          return
        }
        this.movies = data.Search
      } catch (e) {
        this.movies = []
        this.snackbarText = 'Error'
        this.snackbar = true
      }
      this.loading = false
    }
  },
  components: { MovieList }
}
</script>
